;//////////////////////////////////////////////////////////////////////////////
;/// Petezl 2005 //////////////////////////////////////////////////////////////
;/// Example of coloring text and background of a Static control in a dialog //
;//////////////////////////////////////////////////////////////////////////////

.386
.model flat, stdcall
option casemap :none ; case sensitive

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc 

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib 

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
hInstance dd 0

;// Define the colors
YellBrush   dd 0000ffffh
hyellBrush  dd 0
redText     dd 000000ffh

.data?
hStatic1 HANDLE ? 
hStatic2 HANDLE ? 
; 

.code
start:

invoke GetModuleHandle, NULL
mov hInstance, eax
invoke DialogBoxParam,hInstance, 700,0,ADDR DlgProc,0
invoke ExitProcess,eax
; 

DlgProc proc hDlg:DWORD,uMsg:DWORD, wParam:DWORD,lParam:DWORD

.if uMsg == WM_CLOSE
invoke DeleteObject, hyellBrush 
invoke EndDialog,hDlg,0

.elseif uMsg==WM_INITDIALOG

              invoke GetDlgItem,hDlg,4001
              mov hStatic1,eax 

              invoke GetDlgItem,hDlg,4002
              mov hStatic2,eax 
               
              invoke CreateSolidBrush, YellBrush
              mov hyellBrush,eax 

.elseif uMsg == WM_CTLCOLORSTATIC 

                mov eax,lParam 
                
                    .if     eax == hStatic1 
                            invoke GetStockObject, BLACK_BRUSH 
                            ret 
                    .elseif   eax == hStatic2 

                            invoke SetBkMode, wParam, TRANSPARENT 
                            invoke SetTextColor, wParam, redText
                            mov eax, hyellBrush ; background brush color, equivalent of SelectObject
                            ret
                    .endif 

.else
xor eax,eax
ret
.endif
ret
DlgProc endp
; 

end start 
